#ifndef EHXOQT_H
#define EHXOQT_H

#include "PaPreCompile.h" // Q_OBJECT

#include "Individual.h" // Individual
#include "Species.h" // Species

class EhxoQt : public QObject
{
  Q_OBJECT

public:
  bool increaseCandidateAmount(const qint32 & betterDayAmount); //!< 增加候选列表长度，并提供参考的上限值。
  Individual * generate1Iteration(); //!< Generate 1 iteration.
  void setSeedIndividual(Individual *value);
  Individual * getIndividualById(const QString & individualId); //!< Get the invidiaul of this response.
  Individual *getOptimisticIndividual() const;

private:
  void debugIndividualIdMap(); //!< Debug.
  QMap<QString, Individual*> individualIdMap; //!< The individual id to individual map.
  void removeIndividualMapItem(const Individual * individual); //!<Remove indidivual map item.
  void removeCandidateOptimisticIndividual(Individual *individual); //!< Remove candidate optimistic indidivual .
  QMap<QString, Species*> idSpeciesMap; //!< The id to species map.
  Individual * optimisticIndividual = nullptr; //!< The best individual.
  qreal optimisticScore = std::numeric_limits<qreal>::lowest(); //!< optimistic score.
//  void refreshOptimisticIndividual(const qreal & newIndividualScore); //!< Refresh optimistic individual.
  void refreshOptimisticIndividual(Individual *newIndividual); //!< Refresh optimistic individual.
  auto tryInsertCandidateOPtimisticIndividualList(Individual * reportIngIndividual) ; //!< Try to insert into candidate optimistic individual list.
  Individual * seedIndividual=nullptr; //!< The seed individual. Chen xin.
  QList< Individual*> candidateOptimisticIndividualList; //!< The candidate optimistic individual list.
  auto findOptimisticIndividual() const; //!< Find the new optimistic individual
  qint32 maxCandidateOptimisticIndividualAmount=10; //!< Max candidate optimistic individual amount.

signals:
  void optimisticIndividualChanged(const Individual * optimisticIndividual) ; // Emit signal, optimistic individual changed.
};

#endif
